# Index
- CORE
- Docker Setup
    - Precompiled container image
    - Build container image from source
        - Adding extra packages

- Useful commands
- License

# CORE

CORE: Common Open Research Emulator

Copyright (c)2005-2022 the Boeing Company.

See the LICENSE file included in this distribution.

# Docker Setup

Here you have 2 choices

## Precompiled container image

```bash

# Start container
sudo docker run -itd --name core -e DISPLAY -v /tmp/.X11-unix:/tmp/.X11-unix:rw --privileged --restart unless-stopped git.olympuslab.net/afonso/core-extra:latest

```
## Build container image from source

```bash
# Clone the repo
git clone https://gitea.olympuslab.net/afonso/core-extra.git

# cd into the directory
cd core-extra

# build the docker image
sudo docker build -t core-extra .

# start container
sudo docker run -itd --name core -e DISPLAY -v /tmp/.X11-unix:/tmp/.X11-unix:rw --privileged --restart unless-stopped core-extra

```

### Adding extra packages

To add extra packages you must modify the Dockerfile and then compile the docker image.
If you install it after starting the container it will, by docker nature, be reverted on the next boot of the container.

# Useful commands

I have the following functions on my fish shell
to help me better use core

THIS ONLY WORKS ON FISH, MODIFY FOR BASH OR ZSH

```fish

# RUN CORE GUI
function core
    xhost +local:root
    sudo docker exec -it core core-gui
end

# RUN BASH INSIDE THE CONTAINER
function core-bash
    sudo docker exec -it core /bin/bash
end


# LAUNCH NODE BASH ON THE HOST MACHINE
function launch-term --argument nodename
     sudo docker exec -it core xterm -bg black -fg white -fa 'DejaVu Sans Mono' -fs 16 -e vcmd -c /tmp/pycore.1/$nodename -- /bin/bash
end

#TO RUN ANY OTHER COMMAND
sudo docker exec -it core COMAND_GOES_HERE

```

## LICENSE

Copyright (c) 2005-2018, the Boeing Company.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice,
   this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice,
   this list of conditions and the following disclaimer in the documentation
   and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
THE POSSIBILITY OF SUCH DAMAGE.
